//+------------------------------------------------------------------+
//|                                               heikin-ashi-ea.mq5 |
//|                                                           andrea |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|                                                                  |
//|   todo:                                                          |
//|      1. migliorare i setup di entrata e uscita con i patterns    |
//|      2. integrare il money management                            |
//|                                                                  |
//|   bug:                                                           |
//|      1. credo ci sia discrepanza tra le candele dell'indicatore  |
//|         dell' ea                                                 |
//|------------------------------------------------------------------+
#property copyright "andrea"
#property link      "https://www.mql5.com"
#property version   "1.0"


#include <K_Orders.mqh> 
#include <Trade\PositionInfo.mqh>
#include <Trade\Trade.mqh> // trading object
Order order; 
CPositionInfo positionInfo; // trade position object
CTrade cTrade;  
#define EXPERT_MAGIC 1234567890   // MagicNumber of the expert

//MqlTradeResult  result={};

int timeframe = 0;
bool isInBuy = false;
bool isInSell = false;
bool isInTheMarket = false;

int startTime = 0;
int stopTime = 24;

double lots = 1.0;

int OnInit(){

   return(INIT_SUCCEEDED);
}

void OnDeinit(const int reason){
   
}

void OnTick(){

   //close the position
   if(isInTheMarket && isInBuy && isBearCandle()){
      closePosition();
   }else if(isInTheMarket && isInSell && isBullCandle()){
      closePosition();
   }
      
   //open position
   if(!isInTheMarket && isBullCandle() && isMarketTime()){
      buy();
   }else if (!isInTheMarket && isBearCandle() && isMarketTime()){
      sell();
   }
}

bool isBullCandle(){
      
   if(checkCandle() == "bull"){
      return true;
   }else{
      return false;
   }
}

bool isBearCandle(){
   
   if(checkCandle() == "bear" ){
      return true;
   }else{
      return false;
   }
}

string checkCandle(){
   
   string candle;
   
   double openPreviousCandle = iOpen(NULL, PERIOD_CURRENT, 2);
   double closePreviousCandle = iClose(NULL, PERIOD_CURRENT, 2);
   
   double openLastCandle = iOpen(NULL, PERIOD_CURRENT, 1);
   double closeLastCandle = iClose(NULL, PERIOD_CURRENT, 1);
   double highLastCandle = iHigh(NULL, PERIOD_CURRENT, 1);
   double lowLastCandle = iLow(NULL, PERIOD_CURRENT, 1);
   
   double haOpenLastCandle = (openPreviousCandle + closePreviousCandle) / 2;
   double haCloseLastCandle = (openLastCandle + closeLastCandle + highLastCandle + lowLastCandle) / 4;
   
   highLastCandle=MathMax(highLastCandle,MathMax(haOpenLastCandle,haCloseLastCandle));
   lowLastCandle=MathMin(lowLastCandle,MathMin(haOpenLastCandle,haCloseLastCandle));
   
   if ( (haOpenLastCandle < haCloseLastCandle)){// && (haOpenLastCandle == lowLastCandle) ){
      candle = "bull";
   }else if ( (haOpenLastCandle > haCloseLastCandle)){// && (haOpenLastCandle == highLastCandle) ){
      candle = "bear";
   }
     
   return (candle);

}

void buy(){
   printf("buy function");
   order.SetLots(lots);
   order.SetMagic(123);
   if(order.Buy()){
      isInTheMarket = true;
      isInBuy = true;
   }

}

void sell(){
   printf("sell function");
   order.SetLots(lots);
   order.SetMagic(123);
   //order.SetSL_inPoints(SL);
   //order.SetTP_inPoints(TP);
   if(order.Sell()){
      isInTheMarket = true;
      isInSell = true;
   }
   
}

void closePosition(){
   printf("close position function");
 
   printf("try to close order");
   for(int i=PositionsTotal()-1;i>=0;i--){ // returns the number of current position
      if(positionInfo.SelectByIndex(i))     // selects the position by index for further access to its properties
         if(positionInfo.Symbol()==Symbol())
            if(cTrade.PositionClose(positionInfo.Ticket())){ // close a position by the specified symbol
               isInTheMarket = false;
               isInBuy = false;
               isInSell = false;
               printf("position closed");
            }
   }
    
}

bool isMarketTime(){
   string now = TimeToString(TimeLocal());
   int hour = StringSubstr(now, 11, 2);
   
   if((hour > startTime) && (hour < stopTime))
      return true;
   else
      return false;
   
}
